clear;

N = 1000;
n = 10;
x = [-7 -4 -3 -2 -1 0 2 4 7 10];
y = [4 -3 -7 0 2 8 6 -4 5 0];
i = (-7+17/N):(17/N):10;

for m=1:n
    f(m) = y(m);
end

for l=2:n
    for m=n:-1:l
        f(m) = (f(m-1)-f(m))/(x(m-l+1)-x(m));
    end
end

for j=1:N
    NewtonBasis(1) = 1;

    for k=2:n
        NewtonBasis(k) = NewtonBasis(k-1) * (i(j) - x(k-1));
    end
    
    p(j) = f(1) * NewtonBasis(1);
    
    for l=2:n
       p(j) = p(j) + f(l) * NewtonBasis(l);
    end
    
end

plot(i,p)