clear;

N = 1000;
n = 10;
x = [-7 -4 -3 -2 -1 0 2 4 7 10];
y = [4 -3 -7 0 2 8 6 -4 5 0];
w = (-7+17/N):(17/N):10;
for i=1:n
    d(i) = y(i);
end
M = zeros(n-2,n-2);
for i=2:(n-1)
    for j=2:(n-1)
        if (i == j)
            M(i-1,j-1) = 2 * (x(i+1) - x(i-1));
        end
        if (i == j+1)
            M(i-1,j-1) = x(i) - x(j);
        end
        if (i+1 == j)
            M(i-1,j-1) = x(j) - x(i);
        end
    end
end
for i=2:(n-1)
    z(i-1) = 3 * ((d(i+1) - d(i)) / (x(i+1) - x(i)) - (d(i) - d(i-1)) / (x(i) - x(i-1)));
end
b(1) = 0;
b(n) = 0;
b(2:(n-1)) = M\z';
for i=2:n
    a(i-1) = (b(i) - b(i-1)) / (3 * (x(i) - x(i-1)));
    c(i-1) = (d(i) - d(i-1)) / (x(i) - x(i-1)) - (b(i) - b(i-1)) * (x(i) - x(i-1)) / 3 - b(i-1) * (x(i) - x(i-1));
end

for j=1:N
    for i=1:(n-1)
        if(x(i) <= w(j) && w(j)<= x(i+1))
            S(j) = a(i) * (w(j) - x(i))^3 + b(i) * (w(j) - x(i))^2 + c(i) * (w(j) - x(i)) + d(i);
        end
    end
end

plot(w,S)